# coding: utf-8

from __future__ import absolute_import

from flask import json
from six import BytesIO

from openapi_server.models.team import Team  # noqa: E501
from openapi_server.models.team_ball_possession_by_season import TeamBallPossessionBySeason  # noqa: E501
from openapi_server.models.team_by_season import TeamBySeason  # noqa: E501
from openapi_server.models.team_fouls_by_season import TeamFoulsBySeason  # noqa: E501
from openapi_server.models.team_passed_percentage_by_season import TeamPassedPercentageBySeason  # noqa: E501
from openapi_server.models.team_shot_on_goal_by_season import TeamShotOnGoalBySeason  # noqa: E501
from openapi_server.test import BaseTestCase


class TestDefaultController(BaseTestCase):
    """DefaultController integration test stubs"""

    def test_controller_get_ball_possession_by_season(self):
        """Test case for controller_get_ball_possession_by_season

        Returns a list of average ball possession for each team by the season.
        """
        response = self.client.open(
            '/premier-api/ballPossessionAverageBySeason/{seasonId}'.format(season_id=56),
            method='GET')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_controller_get_fouls_by_season(self):
        """Test case for controller_get_fouls_by_season

        Returns a list of average fouls for each team by the season.
        """
        response = self.client.open(
            '/premier-api/foulsAverageBySeason/{seasonId}'.format(season_id=56),
            method='GET')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_controller_get_passed_percentage_by_season(self):
        """Test case for controller_get_passed_percentage_by_season

        Returns a list of average percentage of success passing ball by the season.
        """
        response = self.client.open(
            '/premier-api/passedPercentageAverageBySeason/{seasonId}'.format(season_id=56),
            method='GET')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_controller_get_shot_on_goal_by_season(self):
        """Test case for controller_get_shot_on_goal_by_season

        Returns a list of average shot on goal for each team by the season.
        """
        response = self.client.open(
            '/premier-api/shotOnGoalAverageBySeason/{seasonId}'.format(season_id=56),
            method='GET')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_controller_get_team(self):
        """Test case for controller_get_team

        return a list of all team following by teamId,teamName,teamLogo
        """
        response = self.client.open(
            '/premier-api/team',
            method='GET')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_controller_get_team_by_id(self):
        """Test case for controller_get_team_by_id

        Returns a specific team by id.
        """
        response = self.client.open(
            '/premier-api/teamById/{teamId}'.format(team_id=56),
            method='GET')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_controller_get_team_by_season(self):
        """Test case for controller_get_team_by_season

        Returns 20 team of premier league that have all ranking.
        """
        response = self.client.open(
            '/premier-api/teamBySeason/{seasonId}'.format(season_id=56),
            method='GET')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))


if __name__ == '__main__':
    import unittest
    unittest.main()
